Index: trunk/src/lib/graphics/shader.cc
===================================================================
--- trunk/src/lib/graphics/shader.cc	(revision 9682)
+++ trunk/src/lib/graphics/shader.cc	(revision 9869)
@@ -18,5 +18,4 @@
 #include "shader.h"
 
-#include "stdlibincl.h"
 #include "compiler.h"
 //#include <stdio.h>
@@ -25,5 +24,4 @@
 #include "debug.h"
 
-#include "util/loading/resource_manager.h"
 
 
@@ -33,5 +31,50 @@
 
 
+ObjectListDefinition(Shader);
 
+void Shader::Uniform::setV(unsigned int count, float* vv) const
+{
+  switch (count)
+  {
+    case 1:
+    glUniform1fv(this->uniform, 1, vv);
+    break;
+    case 2:
+    glUniform2fv(this->uniform, 2, vv);
+    break;
+    case 3:
+    glUniform3fv(this->uniform, 3, vv);
+    break;
+    case 4:
+    glUniform4fv(this->uniform, 4, vv);
+    break;
+  }
+}
+void Shader::Uniform::setV(unsigned int count, int* vv) const
+{
+  switch (count)
+  {
+    case 1:
+    glUniform1iv(this->uniform, 1, vv);
+    break;
+    case 2:
+    glUniform2iv(this->uniform, 2, vv);
+    break;
+    case 3:
+    glUniform3iv(this->uniform, 3, vv);
+    break;
+    case 4:
+    glUniform4iv(this->uniform, 4, vv);
+    break;
+  }
+}
+
+
+
+Shader::Shader()
+  : data(new ShaderData)
+{
+
+}
 
 /**
@@ -39,240 +82,27 @@
 */
 Shader::Shader (const std::string& vertexShaderFile, const std::string& fragmentShaderFile)
+  : data(new ShaderData)
 {
-   this->setClassID(CL_SHADER, "Shader");
+  if (!Shader::checkShaderAbility())
+    PRINTF(2)("Your system does not support shaders\n");
+  this->load(vertexShaderFile, fragmentShaderFile);
 
-   this->shaderProgram = 0;
-   this->vertexShader = 0;
-   this->fragmentShader = 0;
-
-   if (GLEW_ARB_shader_objects && GLEW_ARB_shading_language_100)
-     {
-       this->shaderProgram = glCreateProgramObjectARB();
-
-       if (!vertexShaderFile.empty())
-         this->loadShaderProgramm(Shader::Vertex, vertexShaderFile);
-       if (!fragmentShaderFile.empty())
-         this->loadShaderProgramm(Shader::Fragment, fragmentShaderFile);
-
-       this->linkShaderProgram();
-
-    }
-   else
-     {
-       PRINTF(2)("Shaders are not supported on your hardware\n");
-     }
 }
 
+const Shader* Shader::storedShader = NULL;
 
-/**
- * standard deconstructor
- */
-Shader::~Shader ()
+void Shader::activateShader() const
 {
-  if (this->shaderProgram == glGetHandleARB(GL_PROGRAM_OBJECT_ARB))
-    Shader::deactivateShader();
-
-  // delete what has to be deleted here
-  this->deleteProgram(Shader::Vertex);
-  this->deleteProgram(Shader::Fragment);
-
-  if (this->fragmentShader != 0)
+  if (likely (this->getProgram() != 0))
   {
-    glDetachObjectARB(this->shaderProgram, this->fragmentShader);
-    glDeleteObjectARB(this->fragmentShader);
-  }
-  if (this->vertexShader != 0)
-  {
-    glDetachObjectARB(this->shaderProgram, this->vertexShader);
-    glDeleteObjectARB(this->vertexShader);
-  }
-  if (this->shaderProgram != 0)
-  {
-    GLint status = 0;
-    //glLinkProgramARB(this->shaderProgram);
-    glDeleteObjectARB(this->shaderProgram);
-       // link error checking
-    glGetObjectParameterivARB(this->shaderProgram, GL_OBJECT_DELETE_STATUS_ARB, &status);
-    if (status == GL_INVALID_VALUE || status == GL_INVALID_OPERATION)
-      this->printError(this->shaderProgram);
-  }
-}
-
-Shader* Shader::getShader(const std::string& vertexShaderFile, const std::string& fragmentShaderFile)
-{
-  return (Shader*)ResourceManager::getInstance()->load(vertexShaderFile, SHADER,  RP_LEVEL, fragmentShaderFile);
-}
-
-bool Shader::unload(Shader* shader)
-{
-  return ResourceManager::getInstance()->unload(shader);
-}
-
-Shader* Shader::storedShader = NULL;
-
-
-bool Shader::loadShaderProgramm(Shader::Type type, const std::string& fileName)
-{
-  GLhandleARB shader = 0;
-
-  if (type != Shader::Vertex && type != Shader::Fragment)
-    return false;
-  this->deleteProgram(type);
-
-
-  std::string program;
-  if (!readShader(fileName, program))
-    return false;
-
-  if (type == Shader::Vertex && GLEW_ARB_vertex_shader)
-  {
-    this->vertexShaderFile = fileName;
-
-    shader = this->vertexShader = glCreateShaderObjectARB(GL_VERTEX_SHADER_ARB);
-  }
-
-  if (type == Shader::Fragment && GLEW_ARB_fragment_shader)
-  {
-    this->fragmentShaderFile = fileName;
-
-    shader = this->fragmentShader = glCreateShaderObjectARB(GL_FRAGMENT_SHADER_ARB);
-  }
-
-  if (shader != 0)
-  {
-    GLint status = 0;
-    const char* prog = program.c_str();
-
-    glShaderSourceARB(shader, 1, &prog, NULL);
-    glCompileShaderARB(shader);
-    // checking on error.
-    glGetObjectParameterivARB(shader, GL_OBJECT_COMPILE_STATUS_ARB, &status);
-    if (status == GL_INVALID_VALUE || status == GL_INVALID_OPERATION)
-      this->printError(shader);
-    else
-      glAttachObjectARB(this->shaderProgram, shader);
-  }
-  return true;
-}
-
-
-void Shader::linkShaderProgram()
-{
-  GLint status = 0;
-
-  glLinkProgramARB(this->shaderProgram);
-       // link error checking
-  glGetObjectParameterivARB(this->shaderProgram, GL_OBJECT_LINK_STATUS_ARB, &status);
-  if (status == GL_INVALID_VALUE || status == GL_INVALID_OPERATION)
-    this->printError(this->shaderProgram);
-}
-
-
-bool Shader::readShader(const std::string& fileName, std::string& output)
-{
-  char lineBuffer[PARSELINELENGTH];
-
-  std::ifstream shader;
-  shader.open(fileName.c_str());
-  if (!shader.is_open())
-    return false;
-
-
-  while (!shader.eof())
-  {
-    shader.getline(lineBuffer, PARSELINELENGTH);
-    output += lineBuffer;
-    output += "\n";
-  }
-
-
-  shader.close();
-  return true;
-}
-
-
-
-void Shader::activateShader()
-{
-  if (likely (this->shaderProgram != 0))
-  {
-    glUseProgramObjectARB(this->shaderProgram);
+    glUseProgramObjectARB(this->getProgram());
     Shader::storedShader = this;
   }
 }
-
-void Shader::bindShader(const char* name, const float* value, size_t size)
-{
-	if (likely (this->shaderProgram != 0)) {
-		glUseProgramObjectARB(this->shaderProgram);
-
-		unsigned int location = glGetUniformLocationARB(this->shaderProgram, name);
-		/* This is EXPENSIVE and should be avoided. */
-
-		if      (size == 1)  glUniform1fvARB(location, 1, value);
-		else if (size == 2)  glUniform2fvARB(location, 1, value);
-		else if (size == 3)  glUniform3fvARB(location, 1, value);
-		else if (size == 4)  glUniform4fvARB(location, 1, value);
-		else if (size == 9)  glUniformMatrix3fvARB(location, 1, false, value);
-		else if (size == 16) glUniformMatrix4fvARB(location, 1, false, value);
-
-	}
-}
-
 void Shader::deactivateShader()
 {
- if (storedShader != NULL)
-   glUseProgramObjectARB(0);
- Shader::storedShader = NULL;
-}
-
-
-void Shader::deleteProgram(Shader::Type type)
-{
-  GLint status = 0;
-  if (type == Shader::Vertex && this->vertexShader != 0)
-  {
-    this->vertexShaderFile = "";
-    glDetachObjectARB(this->shaderProgram, this->vertexShader);
-    glDeleteObjectARB(this->vertexShader);
-    glGetObjectParameterivARB(this->vertexShader, GL_OBJECT_DELETE_STATUS_ARB, &status);
-    if (status == GL_INVALID_VALUE || status == GL_INVALID_OPERATION)
-      Shader::printError(this->vertexShader);
-    this->vertexShader = 0;
-  }
-  else if (type == Shader::Fragment && this->fragmentShader != 0)
-  {
-    this->fragmentShaderFile = "";
-    glDetachObjectARB(this->shaderProgram, this->fragmentShader);
-    glDeleteObjectARB(this->fragmentShader);
-    glGetObjectParameterivARB(this->fragmentShader, GL_OBJECT_DELETE_STATUS_ARB, &status);
-    if (status == GL_INVALID_VALUE || status == GL_INVALID_OPERATION)
-      Shader::printError(this->fragmentShader);
-    this->fragmentShader = 0;
-  }
-  else
-    return;
-}
-
-
-void Shader::printError(GLhandleARB program)
-{
-  if (program == 0)
-    return;
-
-  int infologLength = 0;
-  int charsWritten  = 0;
-  char *infoLog;
-
-  glGetObjectParameterivARB(program, GL_OBJECT_INFO_LOG_LENGTH_ARB,
-                            &infologLength);
-
-  if (infologLength > 0)
-  {
-    infoLog = new char[infologLength+1];
-    glGetInfoLogARB(program, infologLength, &charsWritten, infoLog);
-    printf("%s\n", infoLog);
-    delete[] infoLog;
-  }
+  if (storedShader != NULL)
+    glUseProgramObjectARB(0);
+  Shader::storedShader = NULL;
 }
 
@@ -288,21 +118,3 @@
 }
 
-void Shader::debug() const
-{
-  PRINT(3)("Shader info: (SHADER: %d)\n", this->shaderProgram);
-  if (this->vertexShader != 0)
-  {
-/*    PRINT(3)("VertexShaderProgramm: number=%d, file='%s'\n", this->vertexShader, this->vertexShaderFile);
-    if (this->vertexShaderSource != NULL)
-      for (unsigned int i = 0; i < this->vertexShaderSource->getCount(); i++)
-        PRINT(3)("%d: %s\n", i, this->vertexShaderSource->getEntry(i));
-  }
-  if (this->fragmentShader != 0)
-  {
-    PRINT(3)("FragmentShaderProgramm: number=%d, file='%s'\n", this->fragmentShader, this->fragmentShaderFile);
-    if (this->fragmentShaderSource != NULL)
-      for (unsigned int i = 0; i < this->fragmentShaderSource->getCount(); i++)
-        PRINT(3)("%d: %s\n", i, this->fragmentShaderSource->getEntry(i));*/
-  }
-}
 
Index: trunk/src/lib/graphics/shader.h
===================================================================
--- trunk/src/lib/graphics/shader.h	(revision 9682)
+++ trunk/src/lib/graphics/shader.h	(revision 9869)
@@ -8,7 +8,5 @@
 
 #include "base_object.h"
-#include "glincl.h"
-#include <vector>
-
+#include "shader_data.h"
 
 // FORWARD DECLARATION
@@ -16,12 +14,12 @@
 
 
-//! A class for ...
+//! The Shader is a Class-wrapper around the OpenGL Shader Language (GLSL).
 class Shader : public BaseObject
 {
+  ObjectListDeclaration(Shader);
 public:
   class Uniform
   {
   public:
-    Uniform(const Shader* shader, const std::string& location) { this->uniform = glGetUniformLocationARB(shader->getProgram(), location.c_str()) ; }
     Uniform(const Shader& shader, const std::string& location) { this->uniform = glGetUniformLocation(shader.getProgram(), location.c_str()) ; };
     Uniform(GLhandleARB shaderProgram, const std::string& location) { this->uniform = glGetUniformLocation(shaderProgram, location.c_str()) ; };
@@ -37,105 +35,48 @@
     void set(int v0, int v1, int v2, int v3) const { glUniform4i(this->uniform, v0, v1, v2, v3); }
 
-    void setV(unsigned int count, float* vv) const
-    {
-      switch (count)
-      {
-        case 1:
-          glUniform1fv(this->uniform, 1, vv);
-          break;
-        case 2:
-          glUniform2fv(this->uniform, 2, vv);
-          break;
-        case 3:
-          glUniform3fv(this->uniform, 3, vv);
-          break;
-        case 4:
-          glUniform4fv(this->uniform, 4, vv);
-          break;
-      }
-    }
-    void setV(unsigned int count, int* vv) const
-    {
-      switch (count)
-      {
-        case 1:
-          glUniform1iv(this->uniform, 1, vv);
-          break;
-        case 2:
-          glUniform2iv(this->uniform, 2, vv);
-          break;
-        case 3:
-          glUniform3iv(this->uniform, 3, vv);
-          break;
-        case 4:
-          glUniform4iv(this->uniform, 4, vv);
-          break;
-      }
-    }
-    private:
+    void setV(unsigned int count, float* vv) const;
+    void setV(unsigned int count, int* vv) const;
+
+  private:
     GLint uniform;
   };
 
-  typedef enum
-  {
-    None       = 0,
-    Fragment   = 1,
-    Vertex     = 2,
-
-    Program    = 4,
-  }
-  Type;
 
 public:
-  Shader(const std::string& vertexShaderFile = "", const std::string& fragmentShaderFile = "");
-  virtual ~Shader();
-  static Shader* getShader(const std::string& vertexShaderFile, const std::string& fragmentShaderFile);
-  static bool unload(Shader* shader);
+  Shader();
+  Shader(const std::string& vertexShaderFile, const std::string& fragmentShaderFile = "");
+
+  Shader& operator=(const Shader& shader) { this->data = shader.data; return *this; };
+  const ShaderData::Pointer& dataPointer() const { return data; };
+  void acquireData(const ShaderData::Pointer& pointer) { this->data = pointer; };
+
+  bool load(const std::string& vertexShaderFile, const std::string& fragmentShaderFile = "")
+    { return this->data->load(vertexShaderFile, fragmentShaderFile); }
+
+
+  Shader::Uniform getUniform(const std::string& location) { return Shader::Uniform(*this, location); }
+
+  GLhandleARB getProgram() const { return this->data->getProgram(); }
+  GLhandleARB getVertexS() const { return this->data->getVertexS(); }
+  GLhandleARB getFragmentS() const { return this->data->getFragmentS(); }
+
+  void activateShader() const;
+  static void deactivateShader();
+
+  void debug() const { this->data->debug(); };
 
 
   static bool checkShaderAbility();
-  void activateShader();
-  void bindShader(const char* name, const float* value, size_t size);
-  static void deactivateShader();
 
-  Shader::Uniform getUniform(const std::string& location) { return Shader::Uniform(this, location); }
+  inline static bool isShaderActive() { return (Shader::storedShader != NULL) ? true : false; };
+  inline static const Shader* getActiveShader() { return Shader::storedShader; };
 
-  bool loadShaderProgramm(Shader::Type type, const std::string& fileName);
-  void deleteProgram(Shader::Type type);
-
-  void linkShaderProgram();
-
-
-  bool readShader(const std::string& fileName, std::string& output);
-
-
-inline static bool shaderActive() { return (Shader::storedShader != NULL)? true : false; };
-  inline static Shader* getActiveShader() { return Shader::storedShader; };
-  inline static void suspendShader() { Shader* currShader = storedShader; if (storedShader!= NULL) { Shader::deactivateShader(); Shader::storedShader = currShader;} };
+  inline static void suspendShader() { const Shader* currShader = storedShader; if (storedShader!= NULL) { Shader::deactivateShader(); Shader::storedShader = currShader;} };
   inline static void restoreShader() { if (storedShader != NULL) storedShader->activateShader(); storedShader = NULL; };
 
+private:
+  ShaderData::Pointer    data;
 
-
-
-  GLhandleARB getProgram() const { return this->shaderProgram; }
-  GLhandleARB getVertexS() const { return this->vertexShader; }
-  GLhandleARB getFragmentS() const { return this->fragmentShader; }
-
-  void debug() const;
-
-  static void printError(GLhandleARB program);
-
-
-private:
-  std::string            fragmentShaderFile;
-  std::string            vertexShaderFile;
-
-  GLhandleARB            shaderProgram;
-
-  GLhandleARB            vertexShader;
-  GLhandleARB            fragmentShader;
-
-
-  static Shader*         storedShader;
+  static const Shader*         storedShader;
 };
 
Index: trunk/src/lib/graphics/shader_data.cc
===================================================================
--- trunk/src/lib/graphics/shader_data.cc	(revision 9869)
+++ trunk/src/lib/graphics/shader_data.cc	(revision 9869)
@@ -0,0 +1,267 @@
+/*
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   ### File Specific:
+   main-programmer: Benjamin Grauer
+   co-programmer: ...
+*/
+
+//#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_
+
+#include "shader_data.h"
+
+#include "stdlibincl.h"
+#include "compiler.h"
+//#include <stdio.h>
+#include <fstream>
+
+#include "debug.h"
+
+
+#ifndef PARSELINELENGTH
+#define PARSELINELENGTH     512       //!< how many chars to read at once
+#endif
+
+
+ObjectListDefinition(ShaderData);
+
+/**
+ * standard constructor
+*/
+ShaderData::ShaderData ()
+{
+  this->registerObject(this, ShaderData::_objectList);
+  this->shaderProgram = 0;
+  this->vertexShader = 0;
+  this->fragmentShader = 0;
+}
+
+
+/// TODO fix that shaders are unloaded first. then loaded
+bool ShaderData::load(const std::string& vertexShaderFile, const std::string& fragmentShaderFile)
+{
+  if (GLEW_ARB_shader_objects && GLEW_ARB_shading_language_100)
+  {
+    this->shaderProgram = glCreateProgramObjectARB();
+
+    if (!vertexShaderFile.empty())
+      this->loadShaderProgramm(ShaderData::Vertex, vertexShaderFile);
+    if (!fragmentShaderFile.empty())
+      this->loadShaderProgramm(ShaderData::Fragment, fragmentShaderFile);
+
+    this->linkShaderProgram();
+
+  }
+  else
+  {
+    PRINTF(2)("Shaders are not supported on your hardware\n");
+  }
+}
+
+/**
+ * standard deconstructor
+ */
+ShaderData::~ShaderData ()
+{
+  if (this->shaderProgram == glGetHandleARB(GL_PROGRAM_OBJECT_ARB))
+    glUseProgramObjectARB(0);
+
+  // delete what has to be deleted here
+  this->deleteProgram(ShaderData::Vertex);
+  this->deleteProgram(ShaderData::Fragment);
+
+  if (this->fragmentShader != 0)
+  {
+    glDetachObjectARB(this->shaderProgram, this->fragmentShader);
+    glDeleteObjectARB(this->fragmentShader);
+  }
+  if (this->vertexShader != 0)
+  {
+    glDetachObjectARB(this->shaderProgram, this->vertexShader);
+    glDeleteObjectARB(this->vertexShader);
+  }
+  if (this->shaderProgram != 0)
+  {
+    GLint status = 0;
+    //glLinkProgramARB(this->shaderProgram);
+    glDeleteObjectARB(this->shaderProgram);
+    // link error checking
+    glGetObjectParameterivARB(this->shaderProgram, GL_OBJECT_DELETE_STATUS_ARB, &status);
+    if (status == GL_INVALID_VALUE || status == GL_INVALID_OPERATION)
+      this->printError(this->shaderProgram);
+  }
+}
+
+bool ShaderData::loadShaderProgramm(ShaderData::Type type, const std::string& fileName)
+{
+  GLhandleARB shader = 0;
+
+  if (type != ShaderData::Vertex && type != ShaderData::Fragment)
+    return false;
+  this->deleteProgram(type);
+
+
+  std::string program;
+  if (!readShader(fileName, program))
+    return false;
+
+  if (type == ShaderData::Vertex && GLEW_ARB_vertex_shader)
+  {
+    this->vertexShaderFile = fileName;
+
+    shader = this->vertexShader = glCreateShaderObjectARB(GL_VERTEX_SHADER_ARB);
+  }
+
+  if (type == ShaderData::Fragment && GLEW_ARB_fragment_shader)
+  {
+    this->fragmentShaderFile = fileName;
+
+    shader = this->fragmentShader = glCreateShaderObjectARB(GL_FRAGMENT_SHADER_ARB);
+  }
+
+  if (shader != 0)
+  {
+    GLint status = 0;
+    const char* prog = program.c_str();
+
+    glShaderSourceARB(shader, 1, &prog, NULL);
+    glCompileShaderARB(shader);
+    // checking on error.
+    glGetObjectParameterivARB(shader, GL_OBJECT_COMPILE_STATUS_ARB, &status);
+    if (status == GL_INVALID_VALUE || status == GL_INVALID_OPERATION)
+      this->printError(shader);
+    else
+      glAttachObjectARB(this->shaderProgram, shader);
+  }
+  return true;
+}
+
+
+void ShaderData::linkShaderProgram()
+{
+  GLint status = 0;
+
+  glLinkProgramARB(this->shaderProgram);
+  // link error checking
+  glGetObjectParameterivARB(this->shaderProgram, GL_OBJECT_LINK_STATUS_ARB, &status);
+  if (status == GL_INVALID_VALUE || status == GL_INVALID_OPERATION)
+    this->printError(this->shaderProgram);
+}
+
+
+bool ShaderData::readShader(const std::string& fileName, std::string& output)
+{
+  char lineBuffer[PARSELINELENGTH];
+
+  std::ifstream shader;
+  shader.open(fileName.c_str());
+  if (!shader.is_open())
+    return false;
+
+
+  while (!shader.eof())
+  {
+    shader.getline(lineBuffer, PARSELINELENGTH);
+    output += lineBuffer;
+    output += "\n";
+  }
+
+
+  shader.close();
+  return true;
+}
+
+void ShaderData::bindShader(const char* name, const float* value, size_t size)
+{
+  if (likely (this->shaderProgram != 0))
+  {
+    glUseProgramObjectARB(this->shaderProgram);
+
+    unsigned int location = glGetUniformLocationARB(this->shaderProgram, name);
+    /* This is EXPENSIVE and should be avoided. */
+
+    if      (size == 1)  glUniform1fvARB(location, 1, value);
+    else if (size == 2)  glUniform2fvARB(location, 1, value);
+    else if (size == 3)  glUniform3fvARB(location, 1, value);
+    else if (size == 4)  glUniform4fvARB(location, 1, value);
+    else if (size == 9)  glUniformMatrix3fvARB(location, 1, false, value);
+    else if (size == 16) glUniformMatrix4fvARB(location, 1, false, value);
+
+  }
+}
+
+void ShaderData::deleteProgram(ShaderData::Type type)
+{
+  GLint status = 0;
+  if (type == ShaderData::Vertex && this->vertexShader != 0)
+  {
+    this->vertexShaderFile = "";
+    glDetachObjectARB(this->shaderProgram, this->vertexShader);
+    glDeleteObjectARB(this->vertexShader);
+    glGetObjectParameterivARB(this->vertexShader, GL_OBJECT_DELETE_STATUS_ARB, &status);
+    if (status == GL_INVALID_VALUE || status == GL_INVALID_OPERATION)
+      ShaderData::printError(this->vertexShader);
+    this->vertexShader = 0;
+  }
+  else if (type == ShaderData::Fragment && this->fragmentShader != 0)
+  {
+    this->fragmentShaderFile = "";
+    glDetachObjectARB(this->shaderProgram, this->fragmentShader);
+    glDeleteObjectARB(this->fragmentShader);
+    glGetObjectParameterivARB(this->fragmentShader, GL_OBJECT_DELETE_STATUS_ARB, &status);
+    if (status == GL_INVALID_VALUE || status == GL_INVALID_OPERATION)
+      ShaderData::printError(this->fragmentShader);
+    this->fragmentShader = 0;
+  }
+  else
+    return;
+}
+
+
+void ShaderData::printError(GLhandleARB program)
+{
+  if (program == 0)
+    return;
+
+  int infologLength = 0;
+  int charsWritten  = 0;
+  char *infoLog;
+
+  glGetObjectParameterivARB(program, GL_OBJECT_INFO_LOG_LENGTH_ARB,
+                            &infologLength);
+
+  if (infologLength > 0)
+  {
+    infoLog = new char[infologLength+1];
+    glGetInfoLogARB(program, infologLength, &charsWritten, infoLog);
+    printf("%s\n", infoLog);
+    delete[] infoLog;
+  }
+}
+
+void ShaderData::debug() const
+{
+  PRINT(3)("ShaderData info: (SHADER: %d)\n", this->shaderProgram);
+  if (this->vertexShader != 0)
+  {
+    /*    PRINT(3)("VertexShaderProgramm: number=%d, file='%s'\n", this->vertexShader, this->vertexShaderFile);
+        if (this->vertexShaderSource != NULL)
+          for (unsigned int i = 0; i < this->vertexShaderSource->getCount(); i++)
+            PRINT(3)("%d: %s\n", i, this->vertexShaderSource->getEntry(i));
+      }
+      if (this->fragmentShader != 0)
+      {
+        PRINT(3)("FragmentShaderProgramm: number=%d, file='%s'\n", this->fragmentShader, this->fragmentShaderFile);
+        if (this->fragmentShaderSource != NULL)
+          for (unsigned int i = 0; i < this->fragmentShaderSource->getCount(); i++)
+            PRINT(3)("%d: %s\n", i, this->fragmentShaderSource->getEntry(i));*/
+  }
+}
+
Index: trunk/src/lib/graphics/shader_data.h
===================================================================
--- trunk/src/lib/graphics/shader_data.h	(revision 9869)
+++ trunk/src/lib/graphics/shader_data.h	(revision 9869)
@@ -0,0 +1,67 @@
+/*!
+ * @file shader_data.h
+ * @brief Definition of the Shader rendering class
+*/
+
+#ifndef _SHADER_DATA_H
+#define _SHADER_DATA_H
+
+#include "base_object.h"
+
+#include "glincl.h"
+#include <vector>
+#include "count_pointer.h"
+
+// FORWARD DECLARATION
+
+
+
+//! The ShaderData is a Class-wrapper around the OpenGL Shader Language (GLSL).
+class ShaderData : public BaseObject
+{
+  ObjectListDeclaration(ShaderData);
+  //! The Type of Shader.
+  typedef enum  {
+    None       = 0,     //!< No Type at all
+    Fragment   = 1,     //!< Fragment Shader.
+    Vertex     = 2,     //!< Vertex Shader.
+    Program    = 4,     //!< Compiled Shader Programm.
+  }  Type;
+
+ public:
+  typedef CountPointer<ShaderData> Pointer;
+public:
+  ShaderData();
+  virtual ~ShaderData();
+
+  bool load(const std::string& vertexShaderFile = "", const std::string& fragmentShaderFile = "");
+
+
+  GLhandleARB getProgram() const { return this->shaderProgram; }
+  GLhandleARB getVertexS() const { return this->vertexShader; }
+  GLhandleARB getFragmentS() const { return this->fragmentShader; }
+
+  void activateShader();
+
+  void debug() const;
+private:
+  void bindShader(const char* name, const float* value, size_t size);
+  void linkShaderProgram();
+  bool readShader(const std::string& fileName, std::string& output);
+  bool loadShaderProgramm(ShaderData::Type type, const std::string& fileName);
+  void deleteProgram(ShaderData::Type type);
+
+  static void printError(GLhandleARB program);
+
+private:
+
+  std::string            fragmentShaderFile;
+  std::string            vertexShaderFile;
+
+  GLhandleARB            shaderProgram;
+
+  GLhandleARB            vertexShader;
+  GLhandleARB            fragmentShader;
+};
+
+#endif /* _SHADER_DATA_H */
Index: trunk/src/lib/graphics/spatial_separation/quadtree.cc
===================================================================
--- trunk/src/lib/graphics/spatial_separation/quadtree.cc	(revision 9682)
+++ trunk/src/lib/graphics/spatial_separation/quadtree.cc	(revision 9869)
@@ -27,4 +27,5 @@
 #define QUADTREE_MATERIAL_COUNT       4
 
+ObjectListDefinition(Quadtree);
 /**
  *  standard constructor
@@ -32,5 +33,5 @@
 Quadtree::Quadtree (const modelInfo* pModelInfo, const int treeDepth)
 {
-  this->setClassID(CL_QUADTREE, "Quadtree");
+  this->registerObject(this, Quadtree::_objectList);
   this->pModelInfo = pModelInfo;
   this->treeDepth = treeDepth;
Index: trunk/src/lib/graphics/spatial_separation/quadtree.h
===================================================================
--- trunk/src/lib/graphics/spatial_separation/quadtree.h	(revision 9682)
+++ trunk/src/lib/graphics/spatial_separation/quadtree.h	(revision 9869)
@@ -21,5 +21,5 @@
 //! A class for quadtree separation of the world
 class Quadtree : public BaseObject {
-
+  ObjectListDeclaration(Quadtree);
 
   public:
Index: trunk/src/lib/graphics/spatial_separation/quadtree_node.cc
===================================================================
--- trunk/src/lib/graphics/spatial_separation/quadtree_node.cc	(revision 9682)
+++ trunk/src/lib/graphics/spatial_separation/quadtree_node.cc	(revision 9869)
@@ -27,5 +27,5 @@
 
 
-
+ObjectListDefinition(QuadtreeNode);
 
 /**
@@ -102,5 +102,5 @@
 void QuadtreeNode::init()
 {
-  this->setClassID(CL_QUADTREE_NODE, "QuadtreeNode");
+  this->registerObject(this, QuadtreeNode::_objectList);
 
   /* init the rest of the variables for both init types */
Index: trunk/src/lib/graphics/spatial_separation/quadtree_node.h
===================================================================
--- trunk/src/lib/graphics/spatial_separation/quadtree_node.h	(revision 9682)
+++ trunk/src/lib/graphics/spatial_separation/quadtree_node.h	(revision 9869)
@@ -26,4 +26,5 @@
 //! A class for a Quadtree Node representation
 class QuadtreeNode : public BaseObject {
+  ObjectListDeclaration(QuadtreeNode);
 
   public:
Index: trunk/src/lib/graphics/spatial_separation/spatial_separation.cc
===================================================================
--- trunk/src/lib/graphics/spatial_separation/spatial_separation.cc	(revision 9682)
+++ trunk/src/lib/graphics/spatial_separation/spatial_separation.cc	(revision 9869)
@@ -24,13 +24,13 @@
 
 
-
+ObjectListDefinition(SpatialSeparation);
 
 /**
- *  standard constructor
+ * @brief standard constructor
  * @param model the model that is to be separated
  * @param overlapSize each box will overlap for a given size
-
-   The boxes are overlaping because this makes collision detection a lot simpler
-
+ *
+ * The boxes are overlaping because this makes collision detection a lot simpler
+ *
  */
 SpatialSeparation::SpatialSeparation (Model* model, float overlapSize)
@@ -39,5 +39,5 @@
   PRINT(3)("+-| (Event) Spatial Separation process kicked on\n");
 
-  this->setClassID(CL_SPATIAL_SEPARATION, "SpatialSeparation");
+  this->registerObject(this, SpatialSeparation::_objectList);
   /* debug vice */
   this->createQuadtree(model);
@@ -46,5 +46,5 @@
 
 /**
- *  standard constructor
+ * @brief standard constructor
  * @param model the model that is to be separated
  * @param overlapSize each box will overlap for a given size
@@ -54,5 +54,5 @@
 SpatialSeparation::SpatialSeparation (Model* model, Model* playerModel)
 {
-  this->setClassID(CL_SPATIAL_SEPARATION, "SpatialSeparation");
+  this->registerObject(this, SpatialSeparation::_objectList);
 
 }
@@ -60,5 +60,5 @@
 
 /**
- *  standard deconstructor
+ * @brief standard deconstructor
  */
 SpatialSeparation::~SpatialSeparation ()
@@ -70,5 +70,5 @@
 
 /**
- *  creates a quadtree
+ * @brief creates a quadtree
  * @param model the model to do a quadtree on
  * @param minLength the minimal length of a quadtree node
@@ -83,5 +83,5 @@
 
 /**
- *  brief creates a quadtree
+ * @brief creates a quadtree
  * @param model the model to do a quadtree on
  * @param minLength the minimal length of a quadtree node
@@ -95,5 +95,5 @@
 
 /**
- *  creates a quadtree
+ * @brief creates a quadtree
  * @param model the model to do a quadtree on
  * @param minLength the minimal length of a quadtree node
@@ -109,5 +109,5 @@
 
 /**
- *  draws all the quadtrees
+ * @brief draws all the quadtrees
  */
 void SpatialSeparation::drawQuadtree()
@@ -118,14 +118,2 @@
   this->quadtree->drawTree();
 }
-
-
-
-
-
-
-
-
-
-
-
-
Index: trunk/src/lib/graphics/spatial_separation/spatial_separation.h
===================================================================
--- trunk/src/lib/graphics/spatial_separation/spatial_separation.h	(revision 9682)
+++ trunk/src/lib/graphics/spatial_separation/spatial_separation.h	(revision 9869)
@@ -19,4 +19,5 @@
 //! A class for spatial separation of vertices based arrays
 class SpatialSeparation : public BaseObject {
+  ObjectListDeclaration(SpatialSeparation);
 
   public:
Index: trunk/src/lib/graphics/text_engine/font.cc
===================================================================
--- trunk/src/lib/graphics/text_engine/font.cc	(revision 9682)
+++ trunk/src/lib/graphics/text_engine/font.cc	(revision 9869)
@@ -29,4 +29,5 @@
 #include "compiler.h"
 
+ObjectListDefinition(Font);
 
 Font::Font()
@@ -34,5 +35,4 @@
 {
   this->init();
-
 }
 
@@ -118,4 +118,5 @@
   Material::operator=(font);
   this->data = font.data;
+  this->setTexture(this->data->textureData());
 
   return *this;
@@ -130,6 +131,6 @@
   this->setBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
 
-  this->setClassID(CL_FONT, "Font");
-  if (Font::defaultFontData.get() == NULL)
+  this->registerObject(this, Font::_objectList);
+  if (Font::defaultFontData.isNull())
   {
     Font::initDefaultFont();
@@ -138,5 +139,5 @@
 }
 
-FontDataPointer Font::defaultFontData(NULL);
+FontData::Pointer Font::defaultFontData(NULL);
 
 /**
@@ -146,5 +147,5 @@
 {
   // temporarily create a Font.
-  Font::defaultFontData = FontDataPointer(new FontData);
+  Font::defaultFontData = FontData::Pointer(new FontData);
   // apply the Data.
   Font::defaultFontData = Font(font_xpm).data;
@@ -159,5 +160,5 @@
 bool Font::loadFontFromTTF(const std::string& fontFile, unsigned int renderSize)
 {
-  this->data = FontDataPointer (new FontData());
+  this->data = FontData::Pointer (new FontData());
   bool retVal = this->data->loadFontFromTTF(fontFile, renderSize);
   if (!retVal)
@@ -174,5 +175,5 @@
 bool Font::loadFontFromSDL_Surface(SDL_Surface* surface)
 {
-  this->data = FontDataPointer (new FontData());
+  this->data = FontData::Pointer (new FontData());
   bool retVal = this->data->loadFontFromSDL_Surface(surface);
   if (!retVal)
@@ -196,5 +197,5 @@
 
 
-void Font::setTexture(const TextureDataPointer& texDataPointer)
+void Font::setTexture(const TextureData::Pointer& texDataPointer)
 {
   this->setDiffuseMap(texDataPointer);
